# fuel ship

name = 'fuelship'
type = 'gif'

from baseairobj import *
from objfuelbox import FuelBox

image = None

import random
DY_CHANGE_INTERVAL = 20
DY     = 0.2
TOP    = game.arena.top
BOTTOM = game.arena.bottom-70

FUELBOX_XOFFSET = 10
FUELBOX_YOFFSET = 10

DROP_POINT = game.arena.right - 70

def load_game_resources():
    global image, name
    image = gfx.load('%s.%s' % (name,type))


class FuelShip(AirObj):
    def __init__(self,airobj_list):
        global name,image
        AirObj.__init__(self,name,image)
        self.airobj_list = airobj_list
        self.dx = 2
        self.x = 2
        self.y = game.arena.top

        self.dropped = 0
        self.drop_point = DROP_POINT

    def tick(self, speedadjust):
        if self.dropped == 0 and self.x > self.drop_point:
            self.airobj_list.append(FuelBox(self.x+FUELBOX_XOFFSET,self.y+FUELBOX_YOFFSET))
            self.dropped = 1

        self.x += self.dx * speedadjust
        if self.x > game.arena.right + self.rect.width:
            self.dead = 1

        self.rect.topleft = [self.x,self.y]
        
    

